# sample latte script
# converts the selected text to upper case
# if no text is selected, is converts the hole buffer
# (C) 2000 Chicane (under GPL)

import string
import latte

if latte.has_selection():
    start = latte.selection_start()
    end = latte.selection_end()
    selection = 1
else:
    start = 0
    end = latte.buffer_size()
    selection = 0
file = latte.get_file_number()
len = latte.get_file_tab_width(file)
latte.freeze()
latte.move_to(start)
pos = start
replaced = 0
count = 0
while pos < end:
    c = latte.get_current_char()
    if c == ' ':
        count = count+1
        if count == len:
            latte.move(1)
            latte.delete_text(pos-(len-1), pos+1)
            latte.insert("\t")
            pos = pos-(len-1)
            replaced = replaced+(len-1)
            end = latte.buffer_size()
            count = 0
    else:
        count = 0
    pos = pos+1
    latte.move_to(pos)
if selection:
    latte.select_area(start, end-replaced)
latte.thaw()
